# Summary

[Home](README.md)

---

- [Installation](book/installation.md)
  - [Pre-built binaries](book/pre-built-binaries.md)
    - [Release URLs](book/release-urls.md)
  - [Installing from source](book/installing-from-source.md)
  - [Updating nextest](book/updating.md)
  - [Windows antivirus and macOS Gatekeeper](book/antivirus-gatekeeper.md)
- [Usage](book/usage.md)
  - [Running tests](book/running.md)
  - [Listing tests](book/listing.md)
  - [Retries and flaky tests](book/retries.md)
  - [Slow tests and timeouts](book/slow-tests.md)
  - [Leaky tests](book/leaky-tests.md)
  - [Filter expressions](book/filter-expressions.md)
  - [Archiving and reusing builds](book/reusing-builds.md)
  - [Partitioning test runs in CI](book/partitioning.md)
  - [Target runners](book/target-runners.md)
  - [Other options](book/other-options.md)
- [Machine-readable output](book/machine-readable.md)
- [Configuration](book/configuration.md)
  - [Environment variables](book/env-vars.md)
  - [Minimum nextest versions](book/minimum-versions.md)
  - [Per-test overrides](book/per-test-overrides.md)
    - [Specifying platforms](book/specifying-platforms.md)
  - [Heavy tests and threads-required](book/threads-required.md)
  - [Test groups and mutual exclusion](book/test-groups.md)
- [JUnit support](book/junit.md)
- [Integrations with other tools](book/integrations.md)
  - [Test coverage](book/test-coverage.md)
  - [The Miri interpreter](book/miri.md)
  - [Criterion benchmarks](book/benchmark-integration.md)
---
- [Stability policy](book/stability.md)
- [Experimental features](book/experimental-features.md)
  - [Setup scripts](book/setup-scripts.md)
---
- [How nextest works](book/how-it-works.md)
  - [Benchmarks](book/benchmarks.md)
  - [Custom test harnesses](book/custom-test-harnesses.md)

---

[Changelog](CHANGELOG.md)
